/*----------------------------------------------------------------
	author: massimo.sala.71@gmail.com
	license: MIT
	pls report bugs/improvements to me
*/

#include "chk_string_mask.h"
#include <string.h>

/*
	functions used by these protocols: mssql, ntp3, pgsql, pjl, socks5, tftp, vnc, x11
*/

char * strpush_szstr_null(char * buffer, const char * szString)
{
	if (buffer == NULL)
		return	NULL;
	if (szString == NULL)
		return	buffer;

	strcpy(buffer, szString);
	return	buffer + strlen(szString) + 1;
}


char * strpush_len_szstr(char * buffer, const char * szString)
{
	size_t l;

	if (buffer == NULL)
		return	NULL;
	if (szString == NULL)
	{
		* buffer = 0;
		return	buffer + 1;
	}
	l = strlen(szString);
	*buffer ++ = l;
	memmove(buffer, szString, l);
	return	buffer + l;
}


bool chk_string_mask(const char * szString, int bytes, const char * szMask)
/* mask:
	9 : digit 0-9
	A : alpha A-Z
	$ : alphanumeric
	` : check the next literal char (9 A $ `)
	other char : check it
*/
{
	if (szString == NULL || szMask == NULL)
		return	false;

	for (int i = 0; i < bytes;)
	{
		char ch = *szString ++;
		char mk = szMask[i ++];

		if (mk == '9')
		{
			if (! isdigit(ch))
				return	false;
		}
		else if (mk == 'A')
		{
			if (ch < 'A' || ch > 'Z')
				return	false;
		}
		else if (mk == '$')
		{
			if (! isdigit(ch) && (ch < 'A' || ch > 'Z'))
				return	false;
		}
		else
		{
			if (mk == '`')
			{
				if (i == bytes)				//!!! invalid mask
					return	false;
				mk = szMask[i ++];
			}
			if (ch == 0 || ch != mk)
				return	false;
		}
	}
	return	true;
}
